#ifndef TILEMAP_MODULE
#define TILEMAP_MODULE

#define BROKEN_TILE	-1

class cImage;
class cAnimation;

class cTilemap
{
public:
    int *map;
    int m_numTiles;
    cTilemap(char *filename);
    ~cTilemap();
    void Draw(int x, int y);
    void BreakTile(int x, int y);
    int getTileIndex(int x, int y);
	bool Load(char *filename);
	void Unload();
	int m_xTiles;
	int m_yTiles;
	void getStart(int *startX, int *startY) const;
	void getGoalTile(int *goalTileX, int *goalTileY) const;
	bool isGoal(int x, int y) const;
	bool isBreakable(int x, int y) const;
	bool isImpassable(int x, int y) const;
	int getNumLines() const;
	char *getLine(int lineIndex);
	int getMaxLineLength() const;
private:
	cAnimation *m_breakAnim;
	bool m_loaded;
	cImage *tile[10];
	int m_startX, m_startY;
	int m_goalTileX, m_goalTileY;
	int m_numImpassable;
	int m_impassable[5];
	int m_numBreakable;
	int m_breakable[5];
	int m_numLines;
	int m_maxLineLength;
	char m_line[10][76];
};

#endif
