// Graphics Header
// Important

#ifndef GRAPHICS_MODULE
#define GRAPHICS_MODULE

class cImage;
struct BITMAP;

class cGraphics
{
	public:
        ~cGraphics () { UnloadModule(); }
		bool Initialize (int new_mode);
		void UnloadModule();
		bool AlreadyInitialized();
		void DrawBuffer ();
		static const int DEBUG_MODE = 0;
		static const int FULLSCREEN = 1;
		static const int WIDESCREEN = 2;
		bool trail_effect_enabled;
		int SCR_WIDTH;
		int SCR_HEIGHT;
		int GetMode();
		void SetMode(int new_mode);
		void DrawText (int x, int y, int r, int g, int b, char *text);
		friend class cImage;
		BITMAP *double_buffer;
	private:
		//BITMAP *double_buffer;
		bool initialized;
		BITMAP *not_loaded;
		int mode;
};

extern cGraphics g_graphics;
#endif
